import VueDynamicForm from './VueDynamicForm/index';
import AllOfField from './fields/AllOfField.vue';
import AnyOfField from './fields/AnyOfField.vue';
import ArrayField from './fields/ArrayField.vue';
import BooleanField from './fields/BooleanField.vue';
import IfThenElse from './fields/IfThenElse.vue';
import NullField from './fields/NullField.vue';
import NumberField from './fields/NumberField.vue';
import ObjectField from './fields/ObjectField.vue';
import OneOfField from './fields/OneOfField.vue';
import SchemaField from './fields/SchemaField.vue';
import StringField from './fields/StringField.vue';
import CheckboxWidget from './widgets/CheckboxWidget.vue';
import DatePickerWidget from './widgets/DatePickerWidget.vue';
import TimePickerWidget from './widgets/TimePickerWidget.vue';
import FieldWidget from './widgets/FieldWidget.vue';
import PasswordWidget from './widgets/PasswordWidget.vue';
import RadioWidget from './widgets/RadioWidget.vue';
import SelectWidget from './widgets/SelectWidget.vue';
import SwitchWidget from './widgets/SwitchWidget.vue';
import TagsInputWidget from './widgets/TagsInputWidget.vue';
import TextareaWidget from './widgets/TextareaWidget.vue';
import UploadWidget from './widgets/UploadWidget.vue';

const components = [
	VueDynamicForm,
	AllOfField,
	AnyOfField,
	ArrayField,
	BooleanField,
	IfThenElse,
	NullField,
	NumberField,
	ObjectField,
	OneOfField,
	SchemaField,
	StringField,
	CheckboxWidget,
	DatePickerWidget,
	TimePickerWidget,
	FieldWidget,
	PasswordWidget,
	RadioWidget,
	SelectWidget,
	SwitchWidget,
	TagsInputWidget,
	TextareaWidget,
	UploadWidget,
];
const names = [
	'VueDynamicForm',
	'AllOfField',
	'AnyOfField',
	'ArrayField',
	'BooleanField',
	'IfThenElse',
	'NullField',
	'NumberField',
	'ObjectField',
	'OneOfField',
	'SchemaField',
	'StringField',
	'CheckboxWidget',
	'DatePickerWidget',
	'TimePickerWidget',
	'FieldWidget',
	'PasswordWidget',
	'RadioWidget',
	'SelectWidget',
	'SwitchWidget',
	'TagsInputWidget',
	'TextareaWidget',
	'UploadWidget',
];

const install = (Vue) => {
	if (install.installed) return;
	components.map((component, index) => Vue.component(names[index], component));
};

if (typeof window !== 'undefined' && window.Vue) {
	install(window.Vue);
}

export default {
	install,
	VueDynamicForm,
	AllOfField,
	AnyOfField,
	ArrayField,
	BooleanField,
	IfThenElse,
	NullField,
	NumberField,
	ObjectField,
	OneOfField,
	SchemaField,
	StringField,
	CheckboxWidget,
	DatePickerWidget,
	TimePickerWidget,
	FieldWidget,
	PasswordWidget,
	RadioWidget,
	SelectWidget,
	SwitchWidget,
	TagsInputWidget,
	TextareaWidget,
	UploadWidget,
};
